SystemOrganization addCategory: #'tODE-Inspector'!

TOView subclass: #TOInspector
	instanceVariableNames: 'basicInspect toggleVisible basicMembers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Inspector'!

!TOInspector methodsFor: 'private' stamp: 'dkh 6/3/2011 15:45'!
basicFieldsFor: anObject

	^self currentSystem inspectorField: #tODEBasicInspectorFields from: anObject class to: nil for: anObject! !

!TOInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 09:28'!
basicInspect

	^basicInspect! !

!TOInspector methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:47'!
basicMembers

	^basicMembers! !

!TOInspector methodsFor: 'private' stamp: 'dkh 6/3/2011 15:44'!
fieldsFor: anObject

	^self currentSystem inspectorField: #tODEInspectorFields from: anObject class to: nil for: anObject! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/23/2011 09:25'!
getMembers
	| members |
	basicMembers := toggleVisible := true.
	basicInspect
		ifTrue: [ members := self basicFieldsFor: self object ]
		ifFalse: [ 
			members := self fieldsFor: self object.
			members isEmpty
				ifTrue: [ 
					members := self basicFieldsFor: self object.
					toggleVisible := false ]
				ifFalse: [ basicMembers := false ] ].
	^ members! !

!TOInspector methodsFor: 'initialize-release' stamp: 'dkh 5/23/2011 09:25'!
initialize

	super initialize.
	basicInspect := toggleVisible := basicMembers := false.! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 6/10/2011 10:26'!
renderBasicMembers: members on: html main: main
	html
		table: [ 
			members
				do: [ :fieldSpec | 
					html
						tableRow: [ 
							html
								tableData: [ 
									fieldSpec hasKey
										ifTrue: [ 
											self
												renderLink: [ :s | 
													self currentSession push: fieldSpec key selecting: fieldSpec keySelectedTab.
													main updateCenterSideHistory: s ]
												with: fieldSpec keyLabel
												on: html ]
										ifFalse: [ fieldSpec keyLabel ifNotNil: [ html text: fieldSpec keyLabel ] ] ].
							html
								tableData: [ 
									fieldSpec hasValue
										ifTrue: [ 
											self
												renderLink: [ :s | 
													self currentSession push: fieldSpec value selecting: fieldSpec valueSelectedTab.
													main updateCenterSideHistory: s ]
												with: fieldSpec valueLabel
												on: html ]
										ifFalse: [ html preformatted: fieldSpec valueLabel ] ] ] ] ]! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/28/2011 08:44'!
renderBasicToggleOn: html main: main
	toggleVisible
		ifTrue: [ 
			self
				renderButton: [ :s | 
					basicInspect := basicInspect not.
					main updateCenterOn: s ]
				label:
					(basicInspect
						ifTrue: [ 'standard inspector' ]
						ifFalse: [ 'basic inspector' ])
				on: html.
			html break ]! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 09:23'!
renderContentOn: html main: main
	self object renderInspectorContentOn: html for: self main: main! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 6/3/2011 15:47'!
renderExtraInspectorContentOn: html main: main

	^self currentSystem extraInspectorRendering: #tODEInspectorExtraRendering from: self object class to: nil for: self object withArguments: {html. main}! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 6/22/2011 15:57'!
renderMembers: members on: html main: main

	basicMembers
		ifFalse: [ self renderExtraInspectorContentOn: html main: main ].
	self renderBasicMembers: members on: html main: main! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:08'!
renderMembersOn: html main: main
	self renderMembers: self getMembers on: html main: main! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 6/22/2011 10:36'!
renderStandardContentOn: html main: main
	| members  |
	members := self getMembers.
	self renderBasicToggleOn: html main: main.
	html break.
	self renderMembers: members on: html main: main! !

!Collection methodsFor: '*tode-inspector' stamp: 'dkh 7/7/2011 07:13'!
tODEInspectorFields
	<tODEInspectorFields>
	| i |
	i := 0.
	^ self asArray
		collect: [ :each | 
			i := i + 1.
			(TOInspectorKeylessFieldSpec new)
				keyLabel: i tODEPrintString;
				value: each ]! !

!Dictionary methodsFor: '*tode-inspector' stamp: 'dkh 5/28/2011 10:12'!
tODEInspectorFields
	<tODEInspectorFields>
	^ self associations
		collect: [ :assoc | 
			(TOInspectorFieldSpec new)
				key: assoc key;
				value: assoc value ]! !

!String methodsFor: '*tode-inspector' stamp: 'dkh 5/28/2011 11:47'!
renderExtraContentOn: html tODEMain: main
	<tODEInspectorExtraRendering>
	"no extra fields"! !

!String methodsFor: '*tode-inspector' stamp: 'dkh 5/28/2011 10:37'!
tODEInspectorFields
	<tODEInspectorFields>
	^ {TOInspectorValuelessFieldSpec new valueLabel: self}! !

!TOObjectFrame methodsFor: '*tode-inspector' stamp: 'dkh 6/14/2011 08:56'!
frameTabSpec
	<tODEFrameTabSpec>
	
	^ (TOTabSpec new)
		id: #tODE;
		receiver: self;
		frame: self;
		label: 'tODE';
		order: 50;
		group: 'tODE';
		renderSelector: #renderFrameTabOn:spec:tOdeMain:! !

!TOObjectFrame methodsFor: '*tode-inspector' stamp: 'dkh 6/10/2011 10:18'!
renderFrameTabOn: html spec: aTOSpecTab tOdeMain: main
	| members inspector |
	inspector := (TOInspector new) frame: self.
	html
		break;
		strong: self label;
		text: ' for ' , self historyLabel.
	inspector
		renderBasicMembers:
			({('root' -> TORoot current).
			('session' -> self currentSession).
			('frame' -> self).
			('object' -> self object).
			('main' -> main)} collect: [ :each | each asKeylessFieldSpec ])
		on: html
		main: main.
	html break; strong: 'frame properties:'.
	members := (self properties associations sorted: [:a :b | a key <= b key ]) collect: [ :each | each asKeylessFieldSpec ].
	html unorderedList: [ inspector renderBasicMembers: members on: html main: main ]! !

!TOSystem methodsFor: '*tode-inspector' stamp: 'dkh 6/3/2011 15:46'!
extraInspectorRendering: pragmaSelector from: aClass to: supClass for: receiver withArguments: arguments
	(Pragma allNamed: pragmaSelector from: aClass to: supClass)
		collect: [ :pragma | ^ receiver perform: pragma method selector withArguments: arguments ].
	^ #()! !

!TOSystem methodsFor: '*tode-inspector' stamp: 'dkh 6/3/2011 15:42'!
inspectorField: pragmaSelector from: aClass to: supClass for: receiver
	(Pragma allNamed: pragmaSelector from: aClass to: supClass)
		collect: [ :pragma | ^ receiver perform: pragma method selector ].
	^ #()! !

!Object methodsFor: '*tode-inspector' stamp: 'dkh 5/29/2011 10:54'!
renderInspectorContentOn: html for: aTOInspector main: main
	"Callback to allow receiver to customize the standard (as opposed to basic) inspector view"
	
	aTOInspector renderStandardContentOn: html main: main! !

!Object methodsFor: '*tode-inspector' stamp: 'dkh 5/29/2011 10:51'!
renderInspectorTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-inspector' stamp: 'dkh 7/7/2011 07:24'!
tODEBasicInspectorFields
	<tODEBasicInspectorFields>
	| members noMembers |
	members := WriteStream on: Array new.
	noMembers := true.
	self class allInstVarNames
		keysAndValuesDo: [ :index :each | 
			noMembers := false.
			members
				nextPut:
					((TOInspectorKeylessFieldSpec new)
						keyLabel: each asString;
						value: (self instVarAt: index)) ].
	self class isVariable
		ifTrue: [ 
			1 to: self basicSize do: [ :index | 
				noMembers := false.
				members
					nextPut:
						((TOInspectorKeylessFieldSpec new)
							keyLabel: index printString;
							value: (self basicAt: index)) ] ].
	noMembers
		ifTrue: [ members nextPut: (TOInspectorValuelessFieldSpec new valueLabel: self tODEPrintString) ].
	^ members contents! !

!Object methodsFor: '*tode-inspector' stamp: 'dkh 5/29/2011 10:50'!
tODEInspectorTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #inspect;
		rendererClass: TOInspector;
		receiver: self;
		label: 'inspect';
		order: 50;
		group: 'basic';
		renderSelector: #renderInspectorTabOn:spec:tOdeMain:! !

Object subclass: #TOInspectorFieldSpec
	instanceVariableNames: 'keyLabel key keySelectedTab valueLabel value valueSelectedTab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Inspector'!

!TOInspectorFieldSpec methodsFor: 'testing' stamp: 'dkh 5/28/2011 10:26'!
hasKey

	^true! !

!TOInspectorFieldSpec methodsFor: 'testing' stamp: 'dkh 5/28/2011 10:38'!
hasValue

	^true! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:57'!
key
	^ key! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:57'!
key: anObject
	key := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:02'!
keyLabel
	keyLabel ifNil: [^self key printStringLimitedTo: 50].
	^ keyLabel! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
keyLabel: anObject
	keyLabel := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:04'!
keySelectedTab
	keySelectedTab ifNil: [ ^#inspect ].
	^ keySelectedTab! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
keySelectedTab: anObject
	keySelectedTab := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:59'!
value
	^ value! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
value: anObject
	value := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 7/7/2011 07:20'!
valueLabel
	valueLabel ifNil: [^self value tODEPrintString].
	^ valueLabel! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
valueLabel: anObject
	valueLabel := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:05'!
valueSelectedTab
	valueSelectedTab ifNil: [ ^#inspect ].
	^ valueSelectedTab! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
valueSelectedTab: anObject
	valueSelectedTab := anObject! !

TOInspectorFieldSpec subclass: #TOInspectorKeylessFieldSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Inspector'!

!TOInspectorKeylessFieldSpec methodsFor: 'testing' stamp: 'dkh 5/28/2011 10:26'!
hasKey

	^false! !

!TOInspectorKeylessFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:36'!
keyLabel
	^ keyLabel! !

TOInspectorKeylessFieldSpec subclass: #TOInspectorValuelessFieldSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Inspector'!

!TOInspectorValuelessFieldSpec methodsFor: 'testing' stamp: 'dkh 5/28/2011 10:38'!
hasValue

	^false! !

!TOInspectorValuelessFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:38'!
valueLabel
	^ valueLabel! !

!Association methodsFor: '*tode-inspector' stamp: 'dkh 5/28/2011 10:52'!
asKeylessFieldSpec
	^ (TOInspectorKeylessFieldSpec new)
		keyLabel: key;
		value: value! !
